/*
* QuickFox Notes by Amin E (InBasic)
* eMail: inb.cor@gmail.com
*
* Source Code License: Mozilla Public License, version 1.1
*/

QuickFoxNotes.simplenote = {
	nativeJSON: null,
	stringsBundle: null,
	token: null,	//null: not initialized; -1: error retrieving data
	email: null,
	password: null,
	notes: [],
	
	initialize: function () {
		this.stringsBundle = _("editor-bundle");
		this.nativeJSON = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON);
	},	
	getToken: function (email, password, fun, force) {
		_("simplenote-status").value = this.stringsBundle.getString('simpleNote10');
		
		var arg = arguments;
		
		if (!force) {
			if (this.token) {
				if (fun) {
					fun.apply(this, Array.slice(arguments, 4));
				}
				return;
			}
		}
	
		if (email) 
			this.email = email;
		if (password) 
			this.password = password;
			
		if (QuickFoxNotes.prefs.getCharPref("simplenotePass") && QuickFoxNotes.prefs.getCharPref("simplenoteUser") && !this.email && !this.password && !force) {
			this.email = QuickFoxNotes.prefs.getCharPref("simplenoteUser");
			this.password = atob(QuickFoxNotes.prefs.getCharPref("simplenotePass"));
		}
		if (!this.email) {
			var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
				.getService(Components.interfaces.nsIPromptService);
			var username = {value: QuickFoxNotes.prefs.getCharPref("simplenoteUser")};
			var password = {value: atob(QuickFoxNotes.prefs.getCharPref("simplenotePass"))};
			var check = {value: false};
			var result = prompts.promptUsernameAndPassword(null, this.stringsBundle.getString('simpleNote11'), this.stringsBundle.getString('simpleNote12'), username, password, this.stringsBundle.getString('simpleNote13'), check);

			if (result)	{
				this.email = username.value;
				this.password = password.value;
				
				if (check.value) {
					QuickFoxNotes.prefs.setCharPref("simplenotePass", btoa(password.value));
					QuickFoxNotes.prefs.setCharPref("simplenoteUser", username.value);
				}
			}
			else 
				return;
		}

		var req = new XMLHttpRequest();  
		req.open("POST", "https://simple-note.appspot.com/api/login", true);
		var creds = btoa("email=" + this.email + "&password=" + this.password);
		req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		req.setRequestHeader("Content-length", 2);
		req.setRequestHeader("Connection", "close");
		req.onreadystatechange = function() {
			if(req.readyState == 4) {
				if(req.status == 200) {
					QuickFoxNotes.simplenote.token = req.responseText;
					QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote8'));
					QuickFoxNotes.simplenote.active("simplenote-login", true, "simplenote-getlist", false, "simplenote-update2", false);
					
					if (fun)
						fun.apply(QuickFoxNotes.simplenote, Array.slice(arg, 4));
				}
				else {
					QuickFoxNotes.simplenote.token = null;
					QuickFoxNotes.simplenote.email = null;
					QuickFoxNotes.simplenote.password = null;
					QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote1'));
					QuickFoxNotes.simplenote.getToken (null, null, null, true);	//Force to ask a new username & password
					return;
				}
			}
		}
		req.send("?" + creds);
	},
	getList: function (num) {
		_("simplenote-status").value = this.stringsBundle.getString('simpleNote10');
		this.active("simplenote-getlist", true);
		
		if (!num)
			num = 1;
		else 
			num += 1;
		if (num > 6) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote9'));
			return;
		}
		
		var listbox = _("simplenote-list")
		while (listbox.firstChild)
			listbox.removeChild(listbox.firstChild);

		this.active('simplenote-update1', true, 'simplenote-get', true, 'simplenote-delete', true);
	
		var req = new XMLHttpRequest();
		req.open('GET', "https://simple-note.appspot.com/api/index?auth=" + this.token + "&email=" + this.email, true);
		req.onreadystatechange = function (aEvt) {
			if (req.readyState == 4) {
				if(req.status == 200) {
					try {
						var list = QuickFoxNotes.simplenote.nativeJSON.decode (req.responseText);
						QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote6') + " " + list.length);
						for (var i = 0; i < list.length; i++) {
							if (list[i].deleted)	//Do not get info of deleted note
								continue;
							var req2 = new XMLHttpRequest(); 
							req2.open('GET', 'https://simple-note.appspot.com/api/note?key=' + list[i].key + "&auth=" + QuickFoxNotes.simplenote.token + '&email=' + QuickFoxNotes.simplenote.email, false); 
							req2.send(null);
							if(req2.status == 200) {
								var listitem = document.createElement("listitem");
								listitem.setAttribute ("label", req2.responseText.match(/.*/));
								listitem.setAttribute ("value", req2.responseText);
								listitem.setAttribute ("key", list[i].key);
								listbox.appendChild(listitem);
							}
							else if (req2.status == 401) {
								QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote2'));
								QuickFoxNotes.simplenote.getToken(null, null, QuickFoxNotes.simplenote.getList, true, num);
								return;
							}
							else if (req2.status == 404) {
								QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote3'));
							}
							else {
								QuickFoxNotes.simplenote.getList(num);
								return;
							}
						}						
					} catch (e) {
						QuickFoxNotes.simplenote.error = e.message;
						QuickFoxNotes.simplenote.handleError();
					}
				}
				else {
					if (req.status == 401) {
						QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote2'));
						QuickFoxNotes.simplenote.getToken(null, null, QuickFoxNotes.simplenote.getList, true);
						return;
					}
					else {
						QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote4'));
						QuickFoxNotes.simplenote.getList(num);

						return;
					}
				}
				QuickFoxNotes.simplenote.active("simplenote-getlist", false);
			}
		};
		req.send(null);
	},
	updateNote: function (key, data, num) {
		_("simplenote-status").value = this.stringsBundle.getString('simpleNote10');
	
		if (!num)
			num = 1;
		else 
			num += 1;
		var req = new XMLHttpRequest();
		req.open("POST", "https://simple-note.appspot.com/api/note?key=" + key + "&auth=" + this.token + "&email=" + this.email, false);
		req.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
		req.send(btoa(
			function (string) {	//http://www.webtoolkit.info/javascript-base64.html
				string = string.replace(/\r\n/g,"\n");
				var utftext = "";
				for (var n = 0; n < string.length; n++) {
					var c = string.charCodeAt(n);
					if (c < 128)
						utftext += String.fromCharCode(c);
					else if((c > 127) && (c < 2048)) {
						utftext += String.fromCharCode((c >> 6) | 192);
						utftext += String.fromCharCode((c & 63) | 128);
					}
					else {
						utftext += String.fromCharCode((c >> 12) | 224);
						utftext += String.fromCharCode(((c >> 6) & 63) | 128);
						utftext += String.fromCharCode((c & 63) | 128);
					}
				}
				return utftext;
			}(data)));
		if(req.status == 200) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote5'));
			if (key) {
				_("simplenote-text").value = data;
				_("simplenote-list").selectedItem.value = data;
				_("simplenote-list").selectedItem.label = data.match(/.*/);
			}
			else {
				var listitem = document.createElement("listitem");
				listitem.setAttribute ("label", data.match(/.*/));
				listitem.setAttribute ("value", data);
				listitem.setAttribute ("key", req.responseText);
				_("simplenote-list").appendChild(listitem);
			}
		}
		else if (req.status == 401) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote2'));
			QuickFoxNotes.simplenote.getToken(null, null, QuickFoxNotes.simplenote.updateNote, true, key, data, num);
			return;
		}
		else if (req.status == 404) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote3'));
			return;
		}
		else {
			if (num < 6) {
				QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote4') + " [" + num + "]");
				QuickFoxNotes.simplenote.updateNote(key, data, num);
			}
			else {
				QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote9'));
			}
			return;
			
		}
	},
	deleteNote: function (key, child, num) {
		_("simplenote-status").value = this.stringsBundle.getString('simpleNote10');
	
		if (!num)
			num = 1;
		else 
			num += 1;
	
		var req = new XMLHttpRequest();
		req.open('GET', "https://simple-note.appspot.com/api/delete?key=" + key + "&auth=" + this.token + "&email=" + this.email, false); 
		req.send(null);
		if(req.status == 200) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote7'));
			_("simplenote-list").removeChild(child);
			QuickFoxNotes.simplenote.active('simplenote-update1', true, 'simplenote-get', true, 'simplenote-delete', true)
		}
		else if (req.status == 401) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote2'));
			QuickFoxNotes.simplenote.getToken(null, null, QuickFoxNotes.simplenote.deleteNote, true, key, child, num);
			return;
		}
		else if (req.status == 404) {
			QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote3'));
			return;
		}
		else {
			if (num < 6) {
				QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote4') + num);
				QuickFoxNotes.simplenote.deleteNote(key, child, num);
			}
			else {
				QuickFoxNotes.simplenote.handleError(QuickFoxNotes.simplenote.stringsBundle.getString('simpleNote9'));
			}
			return;
		}
	},
	active: function () {
		for (var i = 0; i < arguments.length; i += 2) {
			_(arguments[i]).setAttribute('disabled', arguments[i + 1]);
		}
	},
	handleError: function (data) {
		_("simplenote-status").value = data;
	}
}