var qfn_editor = {
	_url: "chrome://qfnotes/content/editor.xul",
	stringsBundle: null,
	
	prefs: Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService).getBranch("extensions.InBasic.QuickFoxNotes."),
	_wm: Components.classes["@mozilla.org/appshell/window-mediator;1"]
			.getService(Components.interfaces.nsIWindowMediator),
	
	get: function (aID) {
		return document.getElementById(aID);
	},
	initialize: function () {
		//Init 
		this.stringsBundle = this.get("overlay-bundle");
		
		Components.utils.import("resource://qfn/openInSingleMode.js");
	
		this.get("qfn.keyset.Key1").setAttribute("modifiers", this.prefs.getCharPref("modifier"));
		this.get("qfn.keyset.Key1").setAttribute("key", this.prefs.getCharPref("key"));
		switch(this.prefs.getIntPref("shortcutWindowType")) {
			case 0:	//Window mode
				this.get("qfn.keyset.Key1").setAttribute("oncommand", "qfn_openInSingleMode.openInWindow();");
				this.get("qfn-backpopup").childNodes[0].setAttribute("key", "qfn.keyset.Key1");
				break;
			case 1:	//Tab mode
				this.get("qfn.keyset.Key1").setAttribute("oncommand", "qfn_openInSingleMode.openInTab();");
				this.get("qfn-backpopup").childNodes[1].setAttribute("key", "qfn.keyset.Key1");
				break;
			case 2:
				this.get("qfn.keyset.Key1").setAttribute("oncommand", "qfn_openInSingleMode.openInSidebar(window);");
				this.get("qfn-backpopup").childNodes[2].setAttribute("key", "qfn.keyset.Key1");
		}

		
		this.show_welcome_screen_if_needed();
		//Check to see whether reminder is required or not
		var sec = this.prefs.getIntPref("ReminderSec");
		if (sec) {
			setTimeout(function () {
				switch(qfn_editor.prefs.getIntPref("reminderWindowType"))
				{
				case 2:
					qfn_openInSingleMode.openInSidebar(window);
					break;
				case 1:
					qfn_openInSingleMode.openInTab(); 
					break;
				default:
					qfn_openInSingleMode.openInWindow();
				}
			}, sec * 1000);
		}
		//Hide icons if required!
		this.get("quickfox-notes-statusbarpanel1").hidden = !this.prefs.getBoolPref("statusbarWindowIcon");
		this.get("quickfox-notes-statusbarpanel2").hidden = !this.prefs.getBoolPref("statusbarTabIcon");
		this.get("quickfox-notes-statusbarpanel3").hidden = !this.prefs.getBoolPref("statusbarAppcontentIcon");
		
		var menu = this.get("contentAreaContextMenu");
		menu.addEventListener("popupshowing", this.contextMenu, false);

	},
	
	show_welcome_screen_if_needed : function() {
		//Detect Firefox version
		var version = "";
		try {
			version = navigator.userAgent.match(/Firefox\/([\d\.]*)/)[1];
		} catch (e) {}
		function welcome (version) {
			if(qfn_editor.prefs.getCharPref("currentVersion") == version)
				return;
			//Showing welcome screen
			setTimeout(function() {
				var newTab = getBrowser().addTab('http://inbasic.mozdev.org/root/ext3/home/index.html#FAQ');
				getBrowser().selectedTab = newTab;
		
			}, 1000);
			qfn_editor.prefs.setCharPref("currentVersion", version);
		}
		
		//FF < 4.*
		if (version < "4.") {
			var em = Components.classes["@mozilla.org/extensions/manager;1"]
							 .getService(Components.interfaces.nsIExtensionManager);
			var addon = em.getItemForID("amin.eft_bmnotes@gmail.com");
			welcome(addon.version);
		}
		//FF > 4.*
		else {
			Components.utils.import("resource://gre/modules/AddonManager.jsm");
			AddonManager.getAddonByID("amin.eft_bmnotes@gmail.com", function(addon) {
				welcome(addon.version);
			});
		}
	},
	clickHandle: function (e) {
		if (e.button == 0) {
			switch(this.prefs.getIntPref('toolbarLeftClick'))
			{
			case 0:
				qfn_openInSingleMode.openInWindow(); 
				break;
			case 1:
				qfn_openInSingleMode.openInTab(); 
				break;
			case 2:
				qfn_openInSingleMode.openInSidebar(window);
			}
		}
		if (e.button == 1) {
			switch(this.prefs.getIntPref('toolbarMiddleClick'))
			{
			case 0:
				qfn_openInSingleMode.openInWindow(); 
				break;
			case 1:
				qfn_openInSingleMode.openInTab(); 
				break;
			case 2:
				qfn_openInSingleMode.openInSidebar(window);
			}
		}
	},
	contextMenu: function () {
		const menuitem1 = qfn_editor.get("qfn-context1");
		const menuitem2 = qfn_editor.get("qfn-context2");

		if(!(gContextMenu)) return;
		
		if(menuitem1){
			menuitem1.hidden = menuitem2.hidden = !(gContextMenu.onLink || gContextMenu.isTextSelected) || qfn_editor.prefs.getBoolPref ("doNoteShowInContext");
		}
	},
	sendToQFN: function (details, data) {
		var text;
		//Find main window
		if (!tabBrowser) {
			var mainWindow = qfn_editor._wm.getMostRecentWindow('navigator:browser');
			var tabBrowser = mainWindow.getBrowser();
		}
		//Post text 
		var postText = (details ? "\n" + "{" : "") + 
				       (details ? tabBrowser.currentURI.spec + "}" : "") + "\n";
		//Find selected text
		if (data) {
			text = data;
		}
		else if (gContextMenu.onLink && !gContextMenu.isTextSelected) {
			text = "\n" + gContextMenu.linkURL +  postText;
		}
		else {
			var focusedWindow = document.commandDispatcher.focusedWindow;	//Taken from QuickNote
			text = "\n" + Components.lookupMethod(focusedWindow, "getSelection").apply(focusedWindow, []) + postText;	// i.e. focusedWindow.getSelection();
		}

		//Find QFN
		var QFN = function () {
			var browserEnumerator = qfn_editor._wm.getEnumerator("navigator:browser");
			while (browserEnumerator.hasMoreElements()) {
				var browserWin = browserEnumerator.getNext();

				var tabbrowser = browserWin.gBrowser;
				
				var numTabs = tabbrowser.browsers.length;
				for (var index = 0; index < numTabs; index++) {
					var currentTab = tabbrowser.tabContainer.childNodes[index];
					var currentTabURL = tabbrowser.getBrowserAtIndex(index).currentURI.spec;

					if (currentTabURL == qfn_editor._url)
						return tabbrowser.getBrowserForTab(currentTab).contentWindow.document.wrappedJSObject;
				}
				var contentsplitter = browserWin.document.getElementById("quickfox-notes-contentsplitter");
				if (contentsplitter.getAttribute("collapsed") == "false")
					return browserWin.document.getElementById("quickfox-notes-browser").contentDocument;
			}
			browserEnumerator = qfn_editor._wm.getEnumerator("editor:qfn");
			while (browserEnumerator.hasMoreElements()) {
				return browserEnumerator.getNext().document;
			}
		}();
		if (!QFN) {
			var str = Components.classes["@mozilla.org/supports-string;1"]
				.createInstance(Components.interfaces.nsISupportsString);
			str.data = text;
			qfn_editor.prefs.setComplexValue("pasteMeAfterInit", Components.interfaces.nsISupportsString, str); 
			
			var win = qfn_openInSingleMode.openInWindow();
			return;
		}
	
		var textbox = QFN.getElementById("editor-tabbox-tabpanels").selectedPanel.getElementsByClassName('notepad')[0];
		var readOnly =  (textbox.getAttribute('readonly') == 'true');
		if (readOnly) {
			alert(qfn_editor.stringsBundle.getString('canNotPaste'));
			return;
		}
		//Insert Text at end of text
		var selStart = textbox.value.length;
		textbox.value = textbox.value + text;
		textbox.selectionStart = selStart;
		textbox.selectionEnd = selStart + text.length + 2;
		
		textbox.editor.selectionController.scrollSelectionIntoView(1 ,1 , true);
		textbox.saveMe = true;
	}
};

window.addEventListener("load", function() {qfn_editor.initialize()}, false); 